// GeckoTIP by Ian Weiner, geckotip@hotmathematician.com
// See license.txt for licensing info (GPL)

const tipVERSION="0.9.0";
var tipGeckoVers, tipGeckoInputFixed=false;
var geckotip, tipPrefService, tipWindowWatcher, tipPref, tipPrefRoot, tipPbi, tipScopeOn;
var tipCi = Components.interfaces, tipCc=Components.classes;	
var tipLastDesc, tipCurrentScopes;
var tipFlashUrlBar=true, tipLastField, tipOtherTIPs, tipPanelOpen=false;
var tipCustom={}, tipProfD, tipCustomFile;
var tipPopNode;

const tipPrefListener = {
  domain: "geckotip.",
  observe: function(subject, topic, prefName) {
    tipUpdate();
  }
}
const tipWindowListener = {
	observe: function(subject, topic, data) {
		function loadHandle(e) {
			var win=e.currentTarget;
			if (!(win.tipInit)) {
				try {
					win.addEventListener("popupshowing",tipPop,true);
					win.addEventListener("blur",tipBlur,true);
					win.addEventListener("focus",tipFocus,true);
					win.addEventListener("click",tipClick,true);
					win.addEventListener("input",tipFlashXUL,false);
				} catch (err) { return; }
			}
			win.removeEventListener("load",loadHandle,false);
		}
		if (topic=="domwindowopened") {
			subject.addEventListener("load",loadHandle,false);
		}
		if (topic=="domwindowclosed") {
			subject.removeEventListener("popupshowing",tipPop,true);
			subject.removeEventListener("blur",tipBlur,true);
			subject.removeEventListener("focus",tipFocus,true);
			subject.removeEventListener("click",tipClick,true);
			subject.removeEventListener("input",tipFlashXUL,false);
		}
	}
}

function tipClose() {
	tipPbi.removeObserver(tipPrefListener.domain, tipPrefListener);
	tipWindowWatcher.unregisterNotification(tipWindowListener);
	if (!tipGeckoInputFixed) {
		document.removeEventListener("DOMNodeInserted",tipNewDOMNodeHandler,false); 
		document.removeEventListener("unload",tipDocClose,false);
	}
	window.removeEventListener("popupshowing",tipPop,true);
	window.removeEventListener("blur",tipBlur,true);
	window.removeEventListener("focus",tipFocus,true);
	window.removeEventListener("click",tipClick,true);
	window.removeEventListener("input",tipFlashXUL,false);

	geckotip=null; tipPrefService=null; tipWindowWatcher=null; tipPref=null; 
	tipPrefRoot=null; tipPbi=null; tipCi=null; tipCc=null; tipLastField=null; 
	tipCustom=null; tipProfD=null; tipCustomFile=null; tipPopNode=null; 
}
function tipDocClose() {
	document.removeEventListener("unload",tipDocClose,false);
	if (!tipGeckoInputFixed) document.removeEventListener("DOMNodeInserted",tipNewDOMNodeHandler,false);
}

function tipUpdate()
{
	tipScopeOn = tipPref.getBoolPref("scoping.on");
	tipOtherTIPs = tipPref.getIntPref("othertips");

	if (document.getElementById("tipEnabledBox-menuitem")) 
		document.getElementById("tipEnabledBox-menuitem").setAttribute("checked",(!tipScopeOn)); 
	if (document.commandDispatcher.focusedElement) 
		document.commandDispatcher.focusedElement.blur();
	if (tipOtherTIPs > 0) {
		if (tipPanelOpen) {
			geckotip.setGrabPanel(0);
			tipPanelOpen=false;
		}
	}
	tipBlur();
}

function tipInit()
{
	try { geckotip = tipCc["@geckotip.mozdev.org/geckotip/fx18;1"].getService(tipCi.iGeckotip);} 
	catch(err) { return; } 

	tipGeckoVers = parseFloat(window.navigator.userAgent.substring(window.navigator.userAgent.lastIndexOf("rv:") + 3));
	if (tipGeckoVers > 1.8) tipGeckoInputFixed = true;
	else if (tipGeckoVers == 1.8) tipGeckoInputFixed = (parseFloat(window.navigator.userAgent.substring(window.navigator.userAgent.lastIndexOf("rv:1.8.") + 7))>=1.0);	
	
	tipPrefService = tipCc["@mozilla.org/preferences-service;1"].getService(tipCi.nsIPrefService);
	tipPref = tipPrefService.getBranch("geckotip.");
	tipPrefRoot = tipPrefService.getBranch(null);
	tipPbi = tipPrefRoot.QueryInterface(tipCi.nsIPrefBranchInternal);
	tipPbi.addObserver(tipPrefListener.domain, tipPrefListener, false);

	if (tipGeckoVers >= 1.8) {
		tipWindowWatcher = tipCc["@mozilla.org/embedcomp/window-watcher;1"].getService(tipCi.nsIWindowWatcher);
		tipWindowWatcher.registerNotification(tipWindowListener);		
	}
	
	var asURL;
	tipProfD = tipCc["@mozilla.org/file/directory_service;1"].getService(tipCi.nsIDirectoryService).QueryInterface(tipCi.nsIProperties).get("ProfD", tipCi.nsILocalFile);
	tipCustomFile = tipCc["@mozilla.org/file/directory_service;1"].getService(tipCi.nsIDirectoryService).QueryInterface(tipCi.nsIProperties).get("ProfD", tipCi.nsILocalFile);
	tipCustomFile.append("geckotip-patterns.js.txt");
	asURL=encodeURI("file:///" + tipCustomFile.path.replace(/\\/g,"/"));
	try { tipCc["@mozilla.org/moz/jssubscript-loader;1"].getService(tipCi.mozIJSSubScriptLoader).loadSubScript(asURL, tipCustom); } catch(err) { }
	if (tipCustom) {
		if (tipCustom.tipMatches) {
			tipMatches = tipCustom.tipMatches;
		}
	}
	if (tipPref.getCharPref("version") != tipVERSION) {
		tipPref.setCharPref("version", tipVERSION); 
		window.openDialog("chrome://geckotip/content/geckotipPrefs.xul", "tipPrefs", "chrome");
	}

	tipUpdate();
	if (!tipGeckoInputFixed) {
		document.addEventListener("DOMNodeInserted",tipNewDOMNodeHandler,false); // needed to fix URL bar focus on new tab creation bug
		document.addEventListener("unload",tipDocClose,false);
	}

	if (tipGeckoVers >= 1.8) {
		window.addEventListener("popupshowing",tipPop,true);
	}
	window.addEventListener("blur",tipBlur,true);
	window.addEventListener("focus",tipFocus,true);
	window.addEventListener("click",tipClick,true);
	window.addEventListener("input",tipFlashXUL,false); // needed to fix Firefox caret tracking bug in XUL textboxes

	window.removeEventListener("load", tipInit, false);
}

function tipPopClose(e)
{
	var i, menu=e.currentTarget;
	var nodes = menu.getElementsByAttribute("id","geckotipItem");
	for (i=nodes.length-1; i>=0; i--) {
		menu.removeChild(nodes[i]);
	}
	tipPopNode=null;
	menu.removeEventListener("popuphiding",tipPopClose,true);
	menu.removeAttribute("geckotip");
}

function tipPopCmd(e)
{
	tipSetCustomRecog(tipPopNode);
}

function tipPop(e)
{
	function check(node) {	
		var tn = node.tagName; var et = node.type; 
		try { if (et) et=et.toLowerCase(); } catch(err) {
			alert(err);
		 }
		if (tn=="TEXTAREA") return true;
		if ((tn=="html:input")||(tn=="INPUT")) {
			if ((et=="")||(et=="text")||(et=="password")||(et=="file")) return true;
		}
		return false;
	}	
	var menu = e.originalTarget; var doc = e.currentTarget.document;
	var tipBundle = document.getElementById("bundle_geckotip");
	//var tipBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://geckotip/locale/geckotip.properties");
	
	var node = e.target;
	var inputNode = doc.getAnonymousElementByAttribute(node,"anonid","input");
	if (inputNode) node = inputNode;
	if (node.mTextbox) node = node.mTextbox;
	if (node.mInputField) node = node.mInputField;
	if (node.inputField) node = node.inputField;
	
	if (check(node)) {
		if (menu.getAttribute("geckotip") != "true") {
			menu.setAttribute("geckotip","true");
			tipPopNode = node;
			var ms = doc.createElement("menuseparator");
			ms.setAttribute("id","geckotipItem");
			menu.appendChild(ms);
			var mi = doc.createElement("menuitem");
			mi.setAttribute("label",tipBundle.getString("tipPopupCustom"));
			mi.setAttribute("id","geckotipItem");
			mi.addEventListener("command",tipPopCmd, false);
			menu.appendChild(mi);
			menu.addEventListener("popuphiding",tipPopClose,true);
		}				
	}
}


function tipNewDOMNodeHandler(e)
{
	if (e.target) {
		if (e.target.nodeName=="tabbrowser") {
			tipFlashUrlBar=true;
		}
	}	
	return true;
}

function tipBlur()
{
	var a, i;
	if (document.getElementById("geckotip-panel-label")) 
		document.getElementById("geckotip-panel-label").value = "---";
	try { 
		a = document.getElementsByAttribute("tipDisonblur","true");
     	for (i=0; i<a.length; i++) {
	     	a[i].setAttribute("disabled","true");
      	}
	} catch(err) { }
	geckotip.unfocused(); 
	geckotip.setScope(IS_DEFAULT);
}

function tipToggleInk()
{	
	tipPref.setBoolPref("scoping.on",(!tipScopeOn));
}

function tipGetKey(fe)
{
	if (fe==null) return "";
	var tn = fe.tagName;
	if (!((tn=="html:input")||(tn=="TEXTAREA")||(tn=="INPUT"))) return "";
	var desc=tipElementDescriptor(fe).d;
	if ((desc=="{}")||(desc=="")) return ""; 
	if (fe.ownerDocument.location.hostname=="") return "";
	return fe.ownerDocument.location.hostname + ":" + desc;
}

function tipSetRecog(elt,s) 
{
	eltKey = tipGetKey(elt); 
	if (eltKey=="") return false;
	if (s != -1) {
		//tipSetScope(s,false); 
		setUnicodePref("scope." + eltKey, s, tipPref);
	}
	else {
		//tipSetScope(IS_DEFAULT,false);
		tipPref.clearUserPref("scope." + eltKey);
	}
	elt.blur();
	elt.focus();
	return true;
}

function tipSetCustomRecog(elt)
{
	var s = {str: ""}; 
	window.openDialog("chrome://geckotip/content/geckotipCustomScope.xul","tipCustomScopes","chrome,modal,resizable", getUnicodePref("scope." + tipGetKey(elt), tipPref),s); 
	if (s.str) tipSetRecog(elt,s.str);	
	elt.blur();
}

function tipGetAdjacentText(td)
{
	var text;
	if (!(td)) return "";
	var colcount=0; rowDone=false;

	var tr = td.parentNode;
	while (td && (!rowDone)) {
		text = td.textContent;
		if (text) {
			if (text.search(/\S/) != -1) { 
				text = text.replace(/\s+/g,"_");
				if (text.length > 20) rowDone=true;
				else return "{" + text + "}";
			}
		}
		colcount = colcount + td.colSpan;
		td = td.previousSibling;
	}
	tr = tr.previousSibling;
	rowDone=false;
	while (tr && (!rowDone)) {
		td = tr.childNodes(0);
		while ((td)&&(colcount>0)) {
			colcount = colcount - td.colSpan;
			if (colcount<=0) {
				text = textOf(td);
				if (text) {
					if (text.search(/\S/) != -1) {
						text = text.replace(/\s+/g,"_");
						if (text.length > 20) rowDone=true;
						else return "{" + text + "}";
					}
				}		
			}
		}
		tr = tr.previousSibling;
	}
	return "{}";
}

function tipElementDescriptor(e)
{
	var gotID=false, gotName=false, tableElem, desc="";
	var ename;

	while ( (e.getAttribute) && ((!gotID)||(!gotName)||(!(tableElem))) )
	{
		if ((!gotID)&&(e.getAttribute("id"))) {
			gotID = true;
			desc=desc + "i[" + e.getAttribute("id") + "]l[" + label_for(e.getAttribute("id")) + "]";			
		}
		if ((!gotName)&&(e.getAttribute("name"))) {
			gotName = true;
			desc=desc + "n[" + e.getAttribute("name") + "]";			
		}
		ename=e.nodeName; if (ename) ename = ename.toLowerCase();
		if ((!(tableElem))&&(ename=="td")) tableElem = e;
		if (e.parentNode) { 
			e=e.parentNode;
		} else { 
			desc="{" + desc+ "}"; 
			return { d: desc.toLowerCase(), t:tipGetAdjacentText(tableElem).toLowerCase() }; 
		}
	}
	desc="{" + desc+ "}"; 
	return { d: desc.toLowerCase(), t:tipGetAdjacentText(tableElem).toLowerCase() }; 
}

function label_for(id)
{
	var labels = document.getElementsByTagName("label");
	for (var i=0;i<labels.length;i++) 
		if (labels[i].htmlFor) 		
			if (labels[i].htmlFor==id)  return labels[i].textContent;
	return "";
}

function tipFocusedOnItem(doc)
{
	var fw = doc.commandDispatcher.focusedWindow;
	if (fw) {
		if (fw.document) {
			// editor mode in firefox, e.g. Gmail HTML email editor
			if (fw.document.designMode) {
				if (fw.document.designMode=="on") return true;
			}
		}
		// thunderbird composition
		if (fw.name=="browser.message.body") return true;
	}
	var fe = doc.commandDispatcher.focusedElement;
	if (fe==null) return false;
	var tn = fe.tagName; var et = fe.type; if (et) et=et.toLowerCase();
	if (tn=="TEXTAREA") return true;
	if ((tn=="html:input")||(tn=="INPUT")) {
		if ((et=="")||(et=="text")||(et=="password")||(et=="file")) return true;
	}
	return false;
}

function tipDebug(e)
{
	geckotip.toggleDebug();	
}

function tipClick(e)
{
	var doc = e.currentTarget.document;
	
	if (tipOtherTIPs==0) return true;
	if (tipOtherTIPs > e.detail) return true;
	if (tipFocusedOnItem(doc)) { 
		if ((tipLastField != doc.commandDispatcher.focusedElement) || (e.detail > 1)) {
			tipLastField = doc.commandDispatcher.focusedElement;
			geckotip.setGrabPanel(tipPref.getIntPref("othertips.dir"));
			tipPanelOpen=true;
		}
	} else {		
		tipLastField = null;
		if (tipPanelOpen) {
			geckotip.setGrabPanel(0);
			tipPanelOpen=false;
		}	
		//tipBlur();
	}
	return true;
}

function tipFocus(e)
{
	var doc = e.currentTarget.document;
	
	tipLastDesc = "N/A"; //debug

	if (!tipFocusedOnItem(doc)) {
		tipBlur();
		if (tipOtherTIPs > 0) {
			if (tipPanelOpen) {
				geckotip.setGrabPanel(0);
				tipPanelOpen=false;
			}
		}
		return true;
	}

	geckotip.focused();

	var fe = doc.commandDispatcher.focusedElement;
	if (fe==null) { tipSetScope(IS_DEFAULT, false); return true; }

	var feKey = tipGetKey(fe);

	if (!tipGeckoInputFixed) {	// hack to fix URL bar not focusing properly when new tab is made
		if (tipFlashUrlBar) {
			tipFlashUrlBar=false;
			if (feKey=="browser:{i[urlbar]l[]}")
			{
				if (fe.value=="") {
					fe.blur();
					fe.focus();
				}
			}
		}
	}

	try { 
		var a,j;
		a = document.getElementsByAttribute("tipDisonblur","true");
     	for (j=0; j<a.length; j++) {
	     	a[j].setAttribute("disabled","false");
     	}
	} catch(err) { }

	if (feKey != "") {
		var s = getUnicodePref("scope." + feKey, tipPref);
		if (s != "") {						
			tipSetScope(s,false);
			return true;
		}
	}

	if (document.getElementById("tip-guess-menuitem"))
		document.getElementById("tip-guess-menuitem").setAttribute("disabled","true");
	var tn = fe.tagName;
	var type = fe.getAttribute("type");
	if (type) type = type.toLowerCase();
	if (tn=="INPUT") {
		if (type=="password")
			{ tipSetScope(IS_PASSWORD, false); return true; }
		else if (type=="file")
			{ tipSetScope(IS_FILE_FULLFILEPATH, false); return true; }
		else if (type=="text" || type==null)
		{
			// it might be the anonymous child of a file input
			if (fe.parentNode.tagName == "INPUT")
			{
				var pt = fe.parentNode.type;
				if (pt) pt = pt.toUpperCase();
				if (pt=="FILE")
				{
					tipSetScope(IS_FILE_FULLFILEPATH, false); 
					return true;
				}
			}
		}
	}

	if (!tipScopeOn) { tipSetScope(IS_DEFAULT, false); return true; }

	var noScopeYet=true;
	// at this point we're done with special cases, lets try guessing scopes
	if ((tn=="html:input")||(tn=="TEXTAREA")||(tn=="INPUT")) 
	{
		var descs = tipElementDescriptor(fe);
		var desc = descs.d + "t:"+descs.t;
		tipLastDesc=desc; //debug
		var i, re;
		
		for (i=0; i < tipMatches.length; i++) 
		{
			if (desc.search(tipMatches[i].pattern) != -1) {
				if (noScopeYet) { 
					tipSetScope(tipMatches[i].code,false); 
					noScopeYet = false; 
				} else { 
					tipSetScope(tipMatches[i].code,true); 
				}
			}
		}
	}
	if (noScopeYet) tipSetScope(IS_DEFAULT, false);
	return true;
} 

function tipSetScope(s, add) 
{
	var bx = document.getElementById("geckotip-panel-label");
	var tipBundle = document.getElementById("bundle_geckotip");
	//var tipBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://geckotip/locale/geckotip.properties");

	var str = String(s);
	var n = str.indexOf("regexp:");
	if (n>=0) {
		geckotip.setRegExp(str.substring(n+7));
		if (tipBundle) tipCurrentScopes = tipBundle.getString("tipScopeRegExp");
		if (n>0) { str = str.substring(0,n-1); add = true; } else { str = ""; }
	}
	if (str) {
		a = str.split(",");
		if (!add) {
			geckotip.setScope(Number(a[0]));
			if (tipBundle) tipCurrentScopes = tipBundle.getString("tipScope" + a[0]);
		}
		for (var i=(add?0:1); i<a.length; i++) {
			geckotip.addScope(Number(a[i]));
			if (tipBundle) {
				var sn = tipBundle.getString("tipScope" + a[i]);
				var re = new RegExp("^"+sn+"/|^"+sn+"$|/"+sn+"/|/"+sn+"$");
				if (tipCurrentScopes.search(re) == -1) {	
					tipCurrentScopes = tipCurrentScopes + "/" + sn;
				}
			}
		}
	}
	if (bx) {
		bx.value = tipCurrentScopes;
		if (!tipScopeOn) bx.value = "(" + bx.value + ")";
	}
}


function tipFlashXUL(e)
{
	if (tipGeckoInputFixed) return true; // this function gets called even when tipGeckoInputFixed=true so we need to check inside
	var x = e.originalTarget; 
	if (!x) return true; 
	if ((x.tagName == "html:input")||(x.tagName == "html:textarea")) {
		x.setSelectionRange(x.selectionStart,x.selectionEnd);
	}
	return true;
}

function tipSendEnter() 
{
	var x = document.commandDispatcher.focusedElement;
	if (!x) return;
	var ev = document.createEvent("KeyEvents");
	ev.initKeyEvent("keypress", true, true, window, false, false, false, false, 13, 13);
	x.dispatchEvent(ev); 
}

function tipCopyCustom()
{
	var str;
	var tipBundle = document.getElementById("bundle_geckotip");
	//var tipBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://geckotip/locale/geckotip.properties");


	if (!(tipBundle)) return;
	if (tipCustomFile.exists()) {
		alert(tipBundle.getFormattedString("customAlreadyExists",[tipCustomFile.path]));
		tipCustomFile.reveal();
		return;
	}
	try { str = tipBundle.getString("patternFileHeader") + getContents("chrome://geckotip/locale/geckotip-patterns.js"); } catch(err) {}
	if (writeFile(tipCustomFile, str) > 0) {
		alert(tipBundle.getFormattedString("customCreated",[tipCustomFile.path]));
		tipCustomFile.reveal();
	} else {
		alert(tipBundle.getString("customError"));
	}
}

function getContents(aURL)
{
  var ioService=Components.classes["@mozilla.org/network/io-service;1"]
    .getService(Components.interfaces.nsIIOService);
  var scriptableStream=Components
    .classes["@mozilla.org/scriptableinputstream;1"]
    .getService(Components.interfaces.nsIScriptableInputStream);

  var channel=ioService.newChannel(aURL,null,null);
  var input=channel.open();
  scriptableStream.init(input);
  var str=scriptableStream.read(input.available());
  scriptableStream.close();
  input.close();
  return str;
}
function writeFile(file, str) 
{
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
			createInstance( Components.interfaces.nsIFileOutputStream );
	outputStream.init(file, 0x04 | 0x08 | 0x20, 0664, 0);
	var result = outputStream.write(str,str.length);
	outputStream.close();
	return result;
}

function getUnicodePref(prefName,prefBranch) {
    if (prefBranch.prefHasUserValue(prefName)) {
		try { return prefBranch.getComplexValue(prefName, Components.interfaces.nsISupportsString).data; } 
		catch(err) { return ""; }
	}
	return "";
}

function setUnicodePref(prefName,prefValue,prefBranch) {
    var sString = tipCc["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    sString.data = prefValue;
    try { prefBranch.setComplexValue(prefName,Components.interfaces.nsISupportsString,sString); }
	catch(err) { }
}

function tipNSResolver(prefix) {
  if(prefix == 'html') {
    return 'http://www.w3.org/1999/xhtml';
  }
  else if(prefix == 'xul') {
    return 'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul';
  }
  else if(prefix == 'rdf') {
    return 'http://www.w3.org/1999/02/22-rdf-syntax-ns#';
  }
  else  {
    return null;
  }
}
